package com.dh.flutterkakaolink;

import android.content.Context;

import com.kakao.kakaolink.v2.KakaoLinkResponse;
import com.kakao.kakaolink.v2.KakaoLinkService;
import com.kakao.message.template.LinkObject;
import com.kakao.message.template.TextTemplate;
import com.kakao.network.ErrorResult;
import com.kakao.network.callback.ResponseCallback;

import java.util.HashMap;
import java.util.Map;

import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;

/** FlutterKakaolinkPlugin */
public class FlutterKakaolinkPlugin implements MethodCallHandler {
    Context mcontext;

  /** Plugin registration. */
  public static void registerWith(Registrar registrar) {
    final FlutterKakaolinkPlugin plugin = new FlutterKakaolinkPlugin(registrar);
    final MethodChannel channel = new MethodChannel(registrar.messenger(), "flutter_kakaolink");
    channel.setMethodCallHandler(plugin);
  }

    private FlutterKakaolinkPlugin(Registrar registrar) {
        mcontext = registrar.context();
    }
    

  @Override
  public void onMethodCall(MethodCall call, final Result result) {
    if (call.method.equals("reqkakalink")) {
        
        String templateId = (String)call.arguments;

        Map<String, String> templateArgs = new HashMap<String, String>();
        templateArgs.put("template_arg1", "value1");
        templateArgs.put("template_arg2", "value2");

        Map<String, String> serverCallbackArgs = new HashMap<String, String>();
        serverCallbackArgs.put("user_id", "${current_user_id}");
        serverCallbackArgs.put("product_id", "${shared_product_id}");

        KakaoLinkService.getInstance().sendCustom(mcontext, templateId, templateArgs, serverCallbackArgs, new ResponseCallback<KakaoLinkResponse>() {
            @Override
            public void onFailure(ErrorResult errorResult) {
                result.success(null);
            }

            @Override
            public void onSuccess(KakaoLinkResponse kakaoresult) {
                result.success(null);
            }
        });        
    } else if (call.method.equals("reqkakalinkText")) {
        TextTemplate params = TextTemplate.newBuilder((String)call.arguments, LinkObject.newBuilder().setWebUrl("https://developers.kakao.com").setMobileWebUrl("https://developers.kakao.com").build()).build();

        Map<String, String> serverCallbackArgs = new HashMap<String, String>();
        serverCallbackArgs.put("user_id", "${current_user_id}");
        serverCallbackArgs.put("product_id", "${shared_product_id}");

        KakaoLinkService.getInstance().sendDefault(mcontext, params, serverCallbackArgs, new ResponseCallback<KakaoLinkResponse>() {
            @Override
            public void onFailure(ErrorResult errorResult) {
                result.success(null);
            }

            @Override
            public void onSuccess(KakaoLinkResponse kakaoresult) {
                result.success(null);
            }
        });
    }
     else {
      result.notImplemented();
    }
  }
}
