#import "FlutterKakaolinkPlugin.h"
#import <KakaoOpenSDK/KakaoOpenSDK.h>
#import <KakaoLink/KakaoLink.h>

@implementation FlutterKakaolinkPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"flutter_kakaolink"
            binaryMessenger:[registrar messenger]];
  FlutterKakaolinkPlugin* instance = [[FlutterKakaolinkPlugin alloc] init];
  [registrar addApplicationDelegate:instance];
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  if ([@"reqkakalink" isEqualToString:call.method]) {  

    NSString *templateId = call.arguments;
NSDictionary *templateArgs = @{@"TITLE": @"MY MESSAGE TEMPLATE",
                               @"DESCRIPTION": @"It's my custom template."};


[[KLKTalkLinkCenter sharedCenter] sendCustomWithTemplateId:templateId templateArgs:templateArgs success:^(NSDictionary<NSString *,NSString *> * _Nullable warningMsg, NSDictionary<NSString *,NSString *> * _Nullable argumentMsg) {
    result(nil);
} failure:^(NSError * _Nonnull error) {
    result(nil);
}];    
    result(nil);
  } else if ([@"reqkakalinkText" isEqualToString:call.method]) {
      result(nil);
  }  
  else {
    result(FlutterMethodNotImplemented);
  }
}

@end
